#include "dfs_fuse.h"

static const int multithreaded = 0;


int ll_fuse_main(int argc, char *argv[])
{
  if(argc < 3) {
    cerr << "Usage: dfs <mount point> [fuse args] <block device>\n";
    return -1;
  }

  string volume(argv[argc-1]);

  struct fuse_chan *ch;
  struct fuse_lowlevel_ops dfs_ops;
  char *mountpoint;
  int err = -1;	
  struct fuse_args args = FUSE_ARGS_INIT(argc-1, argv);
  
  dfs_ops_init(&dfs_ops);
  
  DFS dfs(volume);
  
  if (fuse_parse_cmdline(&args, &mountpoint, NULL, NULL) != -1 && 
      (ch = fuse_mount(mountpoint, &args)) != NULL)
    {
      cout << "MOUNTPOINT " << mountpoint << "\n";
		struct fuse_session *se;

		se = fuse_lowlevel_new(&args, &dfs_ops, sizeof(dfs_ops), 
				       NULL);
		if (se != NULL)
		{
			if (fuse_set_signal_handlers(se) != -1)
			{
				fuse_session_add_chan(se, ch);
				if (multithreaded)
					err = fuse_session_loop_mt(se);
				else
					err = fuse_session_loop(se);
				fuse_remove_signal_handlers(se);
				fuse_session_remove_chan(ch);
			}
			fuse_session_destroy(se);
		}
		fuse_unmount(mountpoint, ch);
	}
	fuse_opt_free_args(&args);

	return err ? 1 : 0;
}

int main(int argc, char *argv[])
{
	char **fuse_argv;
	int fuse_argc = argc;

	if (!(fuse_argv = (char **)malloc((argc+2) * sizeof(char *))))
	{
		fprintf(stderr, "Malloc failed\n");
		exit(1);
	}
	memcpy(fuse_argv, argv, argc * sizeof(char *));
	

	// format should go here?

	return ll_fuse_main(fuse_argc, fuse_argv);
}

