
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>

#include "dfs.h"

bool flip_coin() {
  return (((double) rand() / (double) RAND_MAX) >= 0.5);
}

string random_string(uint32 size) {
  //  int *d = (int *) malloc(size);
  //for(unsigned int i = 0; i < size/sizeof(int); i++)
  //  d[i] = rand();
  string s = string(size, 'q');
  //  free(d);
  return s;
}

void do_log_test(const char *block_dev_path, const char *base_path) {
  cout << "Test log\n";
  DFS dfs(block_dev_path, base_path);
  dfs.read_volume();

  srand(1234767879);

  char buffer[1024];
  for(int i = 0; i < 10; i++) {
    cout << "Write item " << i << " \n"; flush(cout);
    if(flip_coin()) {
      sprintf(buffer,"Test String %d BLAH BLAH BLAH BLAH", i);
      dfs.append_log_object(new TestEntry(string(buffer)));
    } else {
      size_t dsize = rand() % (3 * 256 * 1024);
      DataObject *d = new DataObject(random_string(dsize));
      dfs.append_data_object(d);
      dfs.append_log_object(new TestDataEntry(d));
    }
  }
  dfs.commit_pending_log(true);
  cout << "Write test finished\n";


  
}

int main(int argc, char *argv[]) {
  if(argc != 3) {
    cerr << "Usage: logtest <block device> <base>\n";
    return -1;
  }

  char *volume = argv[1];
  char *base = argv[2];

  cout << "Formatting [wipe]" << volume << "\n";
  if(DFS::format_volume(volume, base, true))
    return -1;
  
  do_log_test(volume,base);
  
  return 0;
}


