
#include <stdio.h>
#include <iostream>
#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdlib.h>

#include "dfs.hh"


int main(int argc, char *argv[]) {
  if(argc != 4) {
    cerr << "Usage: mkdfs3 <block device> <bucket> <root directory hash>\n";
    return -1;
  }

  string volume(argv[1]);
  string bucket(argv[2]);
  string root(argv[3]);

  char *accessKeyIdG = getenv("S3_ACCESS_KEY_ID");

  if (!accessKeyIdG) {
    fprintf(stderr, "Missing environment variable S3_ACCESS_KEY_ID\n");
    return -1;
  }

  string key_id(accessKeyIdG);
  char *secretAccessKeyG = getenv("S3_SECRET_ACCESS_KEY");
  if (!secretAccessKeyG) {
    fprintf(stderr, "Missing environment variable S3_SECRET_ACCESS_KEY\n");
    return -1;
  }
  string secret_key(secretAccessKeyG);

  cout << "Formatting " << volume << "\n";

  LogUseS3ROBase *base = new LogUseS3ROBase(key_id, secret_key, bucket, root);

  if(DFS::format_volume(string(volume), base, true)) {
    cerr << "some kind of error!\n";
    return -1;
  }
  return 0;
}


