#include <stdlib.h>

#include "s3store.hh"

int main(int argc, char *argv[]) {
  // usage: mks3ro <root directory> <bucket>
  
  if(argc != 3) {
    cout << "Usage: mks3ro <root directory> <bucket>\n";
    return -1;
  }

  string root_dir(argv[1]);
  string bucket(argv[2]);

  char *accessKeyIdG = getenv("S3_ACCESS_KEY_ID");

  if (!accessKeyIdG) {
    fprintf(stderr, "Missing environment variable S3_ACCESS_KEY_ID\n");
    return -1;
  }

  string key_id(accessKeyIdG);
  char *secretAccessKeyG = getenv("S3_SECRET_ACCESS_KEY");
  if (!secretAccessKeyG) {
    fprintf(stderr, "Missing environment variable S3_SECRET_ACCESS_KEY\n");
    return -1;
  }
  string secret_key(secretAccessKeyG);
  s3ro::S3HashStore store(bucket, key_id, secret_key);
  string root_key = s3ro::S3RO::create(&store, root_dir);
  cout << "Complete.  Root key is "<< root_key << "\n";
}

