#include "dfs.hh"

#include <stdlib.h>

void assert_correctness(vector<Overlay *> &v) {
  vector<Overlay *>::iterator i, j;

  i = v.begin();
  if(i == v.end()) return;
  j = v.begin();
  j++;
  
  while(j != v.end()) {
    Overlay *a = *i;
    Overlay *b = *j;
    assert(a->offset < a->extent());
    assert(b->offset < b->extent());
    assert(a->extent() <= b->offset);
    i++;
    j++;
  }
  cout << "(correctness ok)\n";
}


int main() {
  srand(123456789);
  long tsize = 99;
  
  FileSummary s;

  Overlay *o;

  for(int i = 0; i < 20000; i++) {
    cout << "=============== ADD OVERLAY " << i << "\n";
    long a = rand() % tsize;
    long b = rand() % tsize;

    if(a == b)
      b += 1;

    if(a > b) {
      long c;
      c = b;
      b = a;
      a = c;
    }
    long offset = a;
    long size = b - a;
    o = new Overlay(offset, size, i, 0);
    s.add_overlay(o);
    assert_correctness(s.content_diff);
  }

  return 0;
};
